VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SpriteSet"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private mSprites() As StdPicture
Private mSpriteMasks() As StdPicture
Private mSpriteCount As Integer
Private mZoom As Integer

Public Property Get Zoom() As Integer
    Zoom = mZoom
End Property

Public Property Let Zoom(newZoom As Integer)
    mZoom = newZoom
End Property

Public Property Get RenderWidth(SpriteIndex As Integer)
    RenderWidth = PicXToPixel(mSprites(SpriteIndex).Width) * (2 ^ mZoom)
End Property

Public Property Get RenderHeight(SpriteIndex As Integer)
    RenderHeight = PicYToPixel(mSprites(SpriteIndex).Height) * (2 ^ mZoom)
End Property

Public Property Get MaxRenderWidth()
    Dim Max As Integer, i As Integer
    Max = 0
    For i = -1 To Count - 1
        If RenderWidth(i) > Max Then Max = RenderWidth(i)
    Next
    MaxRenderWidth = Max
End Property

Public Property Get MaxRenderHeight()
    Dim Max As Integer, i As Integer
    Max = 0
    For i = -1 To Count - 1
        If RenderHeight(i) > Max Then Max = RenderHeight(i)
    Next
    MaxRenderHeight = Max
End Property

Public Property Get Count()
    Count = mSpriteCount
End Property


Public Sub Draw(SpriteIndex As Integer, Dest As PictureBox, xd As Integer, yd As Integer, Optional ByVal Opaque = False)
    If SpriteIndex >= -1 And SpriteIndex < Count Then
        If Not Opaque Then
            'If the sprite index is valid then draw the sprite (and the mask)
            Dest.PaintPicture mSpriteMasks(SpriteIndex), xd, yd, RenderWidth(SpriteIndex), RenderHeight(SpriteIndex), 0, 0, Width(SpriteIndex), Height(SpriteIndex), vbSrcAnd
            Dest.PaintPicture mSprites(SpriteIndex), xd, yd, RenderWidth(SpriteIndex), RenderHeight(SpriteIndex), 0, 0, Width(SpriteIndex), Height(SpriteIndex), vbSrcPaint
        Else
            Dest.Line (xd, yd)-(xd + MaxRenderWidth, yd + MaxRenderHeight), Dest.BackColor, BF
            Dest.PaintPicture mSpriteMasks(SpriteIndex), xd, yd, RenderWidth(SpriteIndex), RenderHeight(SpriteIndex), 0, 0, RenderWidth(SpriteIndex), RenderHeight(SpriteIndex), vbSrcCopy
            Dest.PaintPicture mSprites(SpriteIndex), xd, yd, RenderWidth(SpriteIndex), RenderHeight(SpriteIndex), 0, 0, RenderWidth(SpriteIndex), RenderHeight(SpriteIndex), vbSrcPaint
        End If
    Else
        'TBD: What?
    End If
End Sub

Public Sub LoadFromBitmaps(BaseFileName As String)
    Dim i As Integer, Episode As Integer
    Dim Path As String
    
    i = InStrRev(BaseFileName, "\")
    Episode = Val(Mid$(BaseFileName, i + 1, 1))
    Path = Left(BaseFileName, i)
    Select Case Episode
        Case 1
            mSpriteCount = 11
            ReDim mSprites(-1 To mSpriteCount - 1) As StdPicture
            ReDim mSpriteMasks(-1 To mSpriteCount - 1) As StdPicture
            ExtractPicsFromBitmap Path & "1spr0032.bmp", mSprites(-1), mSpriteMasks(-1) 'Map Keen Sprite
            ExtractPicsFromBitmap Path & "1spr0000.bmp", mSprites(0), mSpriteMasks(0)   'Keen Sprite
            ExtractPicsFromBitmap Path & "1spr0048.bmp", mSprites(1), mSpriteMasks(1)   'Yorp Sprite
            ExtractPicsFromBitmap Path & "1spr0060.bmp", mSprites(2), mSpriteMasks(2)   'Garg Sprite
            ExtractPicsFromBitmap Path & "1spr0075.bmp", mSprites(3), mSpriteMasks(3)   'Vorticon Sprite
            ExtractPicsFromBitmap Path & "1spr0088.bmp", mSprites(4), mSpriteMasks(4)   'Butler Sprite
            ExtractPicsFromBitmap Path & "1spr0098.bmp", mSprites(5), mSpriteMasks(5)   'Tank Sprite
            ExtractPicsFromBitmap Path & "1spr0112.bmp", mSprites(6), mSpriteMasks(6)   'Ice Up-right Sprite*
            ExtractPicsFromBitmap Path & "1spr0112.bmp", mSprites(7), mSpriteMasks(7)   'Ice Up Sprite*
            ExtractPicsFromBitmap Path & "1spr0112.bmp", mSprites(8), mSpriteMasks(8)   'Ice Down Sprite*
            ExtractPicsFromBitmap Path & "1spr0112.bmp", mSprites(9), mSpriteMasks(9)   'Ice Up-left Sprite*
            ExtractPicsFromBitmap Path & "1spr0114.bmp", mSprites(10), mSpriteMasks(10) 'Rope Sprite
        Case 2
            mSpriteCount = 8
            ReDim mSprites(-1 To mSpriteCount - 1) As StdPicture
            ReDim mSpriteMasks(-1 To mSpriteCount - 1) As StdPicture
            ExtractPicsFromBitmap Path & "2spr0032.bmp", mSprites(-1), mSpriteMasks(-1) 'Map Keen Sprite
            ExtractPicsFromBitmap Path & "2spr0000.bmp", mSprites(0), mSpriteMasks(0)   'Keen Sprite
            ExtractPicsFromBitmap Path & "2spr0074.bmp", mSprites(1), mSpriteMasks(1)   'Vorticon Sprite
            ExtractPicsFromBitmap Path & "2spr0048.bmp", mSprites(2), mSpriteMasks(2)   'Kid Sprite
            ExtractPicsFromBitmap Path & "2spr0096.bmp", mSprites(3), mSpriteMasks(3)   'Elite Sprite
            ExtractPicsFromBitmap Path & "2spr0103.bmp", mSprites(4), mSpriteMasks(4)   'Scrub Sprite
            ExtractPicsFromBitmap Path & "2spr0112.bmp", mSprites(5), mSpriteMasks(5)   'Tank Sprite
            ExtractPicsFromBitmap Path & "2spr0126.bmp", mSprites(6), mSpriteMasks(6)   'Platform Sprite
            ExtractPicsFromBitmap Path & "2spr0128.bmp", mSprites(7), mSpriteMasks(7)   'Amoeba Sprite
        Case 3
            mSpriteCount = 19
            ReDim mSprites(-1 To mSpriteCount - 1) As StdPicture
            ReDim mSpriteMasks(-1 To mSpriteCount - 1) As StdPicture
            ExtractPicsFromBitmap Path & "3spr0031.bmp", mSprites(-1), mSpriteMasks(-1) 'Map Keen Sprite
            ExtractPicsFromBitmap Path & "3spr0000.bmp", mSprites(0), mSpriteMasks(0)   'Keen Sprite
            ExtractPicsFromBitmap Path & "3spr0063.bmp", mSprites(1), mSpriteMasks(1)   'Vorticon Sprite
            ExtractPicsFromBitmap Path & "3spr0047.bmp", mSprites(2), mSpriteMasks(2)   'Kid Sprite
            ExtractPicsFromBitmap Path & "3spr0085.bmp", mSprites(3), mSpriteMasks(3)   'Mother Sprite
            ExtractPicsFromBitmap Path & "3spr0122.bmp", mSprites(4), mSpriteMasks(4)   'Meep Sprite
            ExtractPicsFromBitmap Path & "3spr0077.bmp", mSprites(5), mSpriteMasks(5)   'Ninja Sprite
            ExtractPicsFromBitmap Path & "3spr0093.bmp", mSprites(6), mSpriteMasks(6)   'Foob Sprite
            ExtractPicsFromBitmap Path & "3spr0109.bmp", mSprites(7), mSpriteMasks(7)   'Ball Sprite
            ExtractPicsFromBitmap Path & "3spr0111.bmp", mSprites(8), mSpriteMasks(8)   'Jack Sprite
            ExtractPicsFromBitmap Path & "3spr0107.bmp", mSprites(9), mSpriteMasks(9)   'Plat Horz Sprite
            ExtractPicsFromBitmap Path & "3spr0107.bmp", mSprites(10), mSpriteMasks(10) 'Plat Vert Sprite
            ExtractPicsFromBitmap Path & "3spr0067.bmp", mSprites(11), mSpriteMasks(11) 'Vorticon Sprite
            ExtractPicsFromBitmap Path & "3spr0114.bmp", mSprites(12), mSpriteMasks(12) 'Amoeba Sprite
            ExtractPicsFromBitmap Path & "3spr0146.bmp", mSprites(13), mSpriteMasks(13) 'Heart Sprite
            ExtractPicsFromBitmap Path & "3spr0103.bmp", mSprites(14), mSpriteMasks(14) 'Gun Right Sprite
            ExtractPicsFromBitmap Path & "3spr0104.bmp", mSprites(15), mSpriteMasks(15) 'Gun Down Sprite
            ExtractPicsFromBitmap Path & "3spr0000.bmp", mSprites(16), mSpriteMasks(16) 'Arm Sprite* TBD
            ExtractPicsFromBitmap Path & "3spr0000.bmp", mSprites(17), mSpriteMasks(17) 'Left Leg Sprite*
            ExtractPicsFromBitmap Path & "3spr0000.bmp", mSprites(18), mSpriteMasks(18) 'Right Leg Sprite*
            'TBD: What about messie's track on the map?
        Case Else
            'We got an error here
    End Select
    
    CreateCustomSprites Episode
End Sub

Private Sub CreateCustomSprites(Episode As Integer)
    Select Case Episode
        Case 1
        Case 3
    End Select
End Sub

Public Property Get Sprites(ByVal SpriteIndex As Integer)
    Set Sprites = mSprites(SpriteIndex)
End Property

Public Property Get SpriteMasks(ByVal SpriteIndex As Integer)
    Set SpriteMasks = mSpriteMasks(SpriteIndex)
End Property

Public Sub LoadFromSpriteSet(s As SpriteSet)
    Dim i As Integer
    mSpriteCount = s.Count
    ReDim mSprites(-1 To mSpriteCount - 1) As StdPicture
    ReDim mSpriteMasks(-1 To mSpriteCount - 1) As StdPicture
    For i = -1 To mSpriteCount - 1
        Set mSprites(i) = s.Sprites(i)
        Set mSpriteMasks(i) = s.SpriteMasks(i)
    Next
End Sub

Private Sub Class_Initialize()
    Dim i As Integer
    mSpriteCount = 0
    ReDim mSprites(-1 To mSpriteCount - 1) As StdPicture
    ReDim mSpriteMasks(-1 To mSpriteCount - 1) As StdPicture
    For i = -1 To mSpriteCount - 1
        Set mSprites(i) = New StdPicture
        Set mSpriteMasks(i) = New StdPicture
    Next
    
    mZoom = 0
End Sub

Public Function Clone() As SpriteSet
    Dim NewSet As New SpriteSet
    NewSet.LoadFromSpriteSet Me
    Set Clone = NewSet
End Function


Private Sub ExtractPicsFromBitmap(Filename As String, ByRef pImage As Picture, ByRef pMask As Picture)
    Dim pSrc As Picture
    Dim w As Integer, h As Integer
        
    Set pSrc = LoadPicture(Filename)
        
    w = PicXToPixel(pSrc.Width) \ 3
    h = PicYToPixel(pSrc.Height)
    frmMain.picDest.Move 0, 0, w, h
    
    'First get the image
    frmMain.picDest.Cls
    frmMain.picDest.PaintPicture pSrc, 0, 0, w, h, 0, 0, w, h, vbSrcCopy
    Set pImage = frmMain.picDest.Image
    
    'Then get the mask
    frmMain.picDest.Cls
    frmMain.picDest.PaintPicture pSrc, 0, 0, w, h, w, 0, w, h, vbSrcCopy
    Set pMask = frmMain.picDest.Image
End Sub


Public Property Get Width(SpriteIndex As Integer)
    Width = PicXToPixel(mSprites(SpriteIndex).Width)
End Property

Public Property Get Height(SpriteIndex As Integer)
    Height = PicYToPixel(mSprites(SpriteIndex).Height)
End Property

