VERSION 5.00
Begin VB.MDIForm frmMain 
   BackColor       =   &H8000000C&
   Caption         =   "KeenWright v0.5"
   ClientHeight    =   4665
   ClientLeft      =   1800
   ClientTop       =   1830
   ClientWidth     =   9660
   LinkTopic       =   "MDIForm1"
   WindowState     =   2  'Maximized
   Begin VB.PictureBox Picture1 
      Align           =   3  'Align Left
      BorderStyle     =   0  'None
      Height          =   4665
      Left            =   0
      ScaleHeight     =   311
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   37
      TabIndex        =   0
      Top             =   0
      Visible         =   0   'False
      Width           =   555
      Begin VB.PictureBox picDest 
         Appearance      =   0  'Flat
         AutoRedraw      =   -1  'True
         BackColor       =   &H00FFFFFF&
         BorderStyle     =   0  'None
         ForeColor       =   &H80000008&
         Height          =   975
         Left            =   0
         ScaleHeight     =   65
         ScaleMode       =   3  'Pixel
         ScaleWidth      =   97
         TabIndex        =   1
         Top             =   0
         Width           =   1455
      End
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileNew 
         Caption         =   "&New"
         Shortcut        =   ^N
      End
      Begin VB.Menu mnuFileOpen 
         Caption         =   "&Open"
         Shortcut        =   ^O
      End
      Begin VB.Menu mnuSeparator 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileSetPaths 
         Caption         =   "Set &Paths"
      End
      Begin VB.Menu mnuSeparator2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
         Shortcut        =   ^Q
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private mTileSets(0 To 2) As TileSet
Private mSpriteSets(0 To 2) As SpriteSet

Private Paths(0 To 2) As String

Private Sub MDIForm_Load()
    Dim i As Integer
    
    If GetPaths() = False Then
        Unload Me
    Else
        SetTiles
    End If
End Sub

Public Sub mnuFileExit_Click()
    Unload Me
End Sub

Public Sub mnuFileNew_Click()
    Dim f As New frmProperties
    Dim Episode As Integer
    
    f.Show 1
    'Wait for user to click OK or Cancel
    
    If Not f.Cancelled Then
        Dim f2 As New frmEdit
        
        Episode = f.lstEpisode.ListIndex + 1
        f2.SetTiles mTileSets(Episode - 1)
        f2.SetSprites mSpriteSets(Episode - 1)
        f2.NewLevel Val(f.txtWidth), Val(f.txtHeight), Episode, IIf(f.chkMapLevel.Value = 0, 1, 80)
        f2.Display
    End If
End Sub

Public Sub mnuFileOpen_Click()
    Dim dlg As New cCommonDialog, Filename As String
    
    If dlg.VBGetOpenFileName(Filename, "", True, False, False, True, "All Levels|Level??.ck?|Keen 1 Levels|Level??.ck1|Keen 2 Levels|Level??.ck2|Keen 3 Levels|Level??.ck3", 1, App.Path & "\levels", "Open Levels", "", Me.hWnd, OFN_EXPLORER Or OFN_LONGNAMES) Then
        
        Dim f As New frmEdit
        Episode = Val(Right(Filename, 1))
        f.SetTiles mTileSets(Episode - 1)
        f.SetSprites mSpriteSets(Episode - 1)
        f.LoadLevel Filename
        f.Display
    End If
End Sub

Public Property Get TileSets(Index As Integer) As TileSet
    Set TileSets = mTileSets(Index)
End Property

Public Property Get SpriteSets(Index As Integer) As SpriteSet
    Set SpriteSets = mSpriteSets(Index)
End Property

Private Sub mnuFileSetPaths_Click()
    Call GetUserPaths
End Sub

Private Function GetUserPaths() As Boolean
    Dim i As Integer
    Load frmSetPaths
    For i = 0 To 2
        frmSetPaths.txtPath(i).Text = Paths(i)
    Next
    frmSetPaths.Show 1
    If Not frmSetPaths.Cancelled Then
        'Set the paths and reload tiles
        For i = 0 To 2
            Paths(i) = frmSetPaths.txtPath(i).Text
        Next
        SaveINISetting "Paths", "Keen 1", Paths(0)
        SaveINISetting "Paths", "Keen 2", Paths(1)
        SaveINISetting "Paths", "Keen 3", Paths(2)
        SetTiles
        GetUserPaths = True
    Else
        GetUserPaths = False
    End If
    Unload frmSetPaths
End Function

Private Function GetPaths() As Boolean
    Dim s As String, i As Integer
    Paths(0) = GetINISetting("Paths", "Keen 1")
    Paths(1) = GetINISetting("Paths", "Keen 2")
    Paths(2) = GetINISetting("Paths", "Keen 3")
        
    If Paths(0) = "" Or Paths(1) = "" Or Paths(2) = "" Then
        GetPaths = GetUserPaths()
    Else
        GetPaths = True
    End If
End Function

Private Sub SetTiles()
    On Error GoTo SetTilesError
    For i = 0 To 2
        Set mTileSets(i) = New TileSet
    Next
    mTileSets(0).LoadFromBitmap Paths(0) & "\1til0000.bmp"
    mTileSets(1).LoadFromBitmap Paths(1) & "\2til0000.bmp"
    mTileSets(2).LoadFromBitmap Paths(2) & "\3til0000.bmp"

    For i = 0 To 2
        Set mSpriteSets(i) = New SpriteSet
    Next
    mSpriteSets(0).LoadFromBitmaps Paths(0) & "\1spr0000.bmp"
    mSpriteSets(1).LoadFromBitmaps Paths(1) & "\2spr0000.bmp"
    mSpriteSets(2).LoadFromBitmaps Paths(2) & "\3spr0000.bmp"
    
    Exit Sub

SetTilesError:
    On Error GoTo 0
    Err.Clear
    MsgBox "One or more of the image paths did not contain the required images!" & vbCrLf & "Please re-enter the paths.", vbCritical
    mnuFileSetPaths_Click
End Sub
